##########################
#####   HUD&base  ########
##########################
execute as @a run function first:base/players
execute as @a[tag=magik] at @s run function first:base/hud
execute as @a[tag=op,tag=!magik] at @s run title @s actionbar [{"text":" \u0020   \u0020   \u0020   \u0020   \u0020   \u0020 \u0020 \u0020 \u0020","color":"#CCCC00"},{"score":{"name":"@s","objective":"mana"},"color":"#CCCC00"},{"text":"/","color":"#CCCC00"},{"score":{"name":"@s","objective":"Maxmana"},"color":"#CCCC00"},{"text":" \u2726","color":"#CCCC00"}]
execute as @a[predicate=first:switches_spell,tag=magik] at @s run scoreboard players add @s counter1 1 
execute as @a at @s run scoreboard players add @s OutOfWater 1
execute as @a[scores={OutOfWater=-1200..},predicate=first:in_water] at @s run scoreboard players remove @s OutOfWater 10
execute as @a at @s if score @s waterD matches 1.. run scoreboard players remove @s OutOfWater 1200
execute as @a at @s if score @s waterD matches 1.. run tellraw @s[tag=qualak] {"text": "You feel refreshed!","color":"#00ccff"}
execute as @a at @s if score @s waterD matches 1.. run scoreboard players remove @s waterD 1
execute as @a[scores={OutOfWater=-1200..}] at @s if predicate first:rain if predicate first:check_sky run scoreboard players remove @s OutOfWater 10
execute as @e[type=#first:sword_users] at @s run function first:base/health
execute as @a[scores={Death=1..}] at @s run function first:base/death


execute as @a[predicate=first:artifact/cube_old] at @s run item modify entity @s weapon.offhand first:updater_c
execute as @a[predicate=first:has_wand_l_old] at @s run item modify entity @s weapon.offhand first:updater_w
execute as @a[predicate=first:has_wand_r_old] at @s run item modify entity @s weapon.mainhand first:updater_w
##########################
#####  Player setup  #####
##########################

execute as @a[tag=!human,tag=!god,tag=!lutuk,tag=!xuluak,tag=!renwik,tag=!qualak,tag=!cerglan,tag=!therwin,tag=!skulkin,tag=!chorusian] at @s run function first:join


#############
### Gems  ###
#############
execute as @a[tag=magik] at @s run function first:gem/echo_shard

##################
##### Scrolls ####
##################
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{manaBurst:1}}}}] at @s run function first:consumables/mburst
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{rainStone:1}}}}] at @s run function first:consumables/rstone
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{arrowsCall:1}}}}] at @s run function first:consumables/errow
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{desolate:1}}}}] at @s run function first:consumables/desolate
execute as @e[type=area_effect_cloud,tag=errow] at @s run function first:consumables/errow2
execute as @e[type=arrow,tag=marrow,nbt={inGround:1b}] at @s run kill @s
execute as @e[type=arrow,tag=marrow] at @s run particle electric_spark ~ ~ ~ 0 0 0 0 1 normal @a
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{motivationScroll:1}}}}] at @s run function first:consumables/motscroll
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{cleanseScroll:1}}}}] at @s run function first:consumables/cleanscroll

##########################
#####  Artifacts  ########
##########################
execute as @e[type=#first:sword_users,tag=!chaosMagik] if predicate first:artifact/chaosstaff at @s run damage @s 2 magic

##########################
#####  Spells ############
##########################
execute as @e[scores={SpellCD = 1..}] at @s run scoreboard players remove @s SpellCD 1
execute as @e[scores = {SpellCD = ..-1}] at @s run scoreboard players add @s SpellCD 1

execute as @a[scores={SpellCD = 1..}] run function first:spellfc/magiccd
execute as @a[scores={SpellCD = 0}] run function first:spellfc/magicenab
execute as @e[scores={SpellCD = 0},tag=wallM] run function first:spellfc/rusmu/rusmu2

execute as @a[tag=magik,predicate=first:has_wand,advancements={first:hidden/wand=true}] at @s run function first:spellfc/cast
##execute as @a[tag=magik,predicate=first:has_wand,scores={WUse=1..}] at @s run function first:spellfc/cast
execute as @a[predicate=first:switches_spell,predicate=first:has_wand_r,tag=magik] at @s if score @s counter1 matches 5 run function first:spellfc/sppick
execute as @a[predicate=first:switches_spell,predicate=first:has_wand_l,tag=magik] at @s if score @s counter1 matches 5 run function first:spellfc/sppick_kontra

execute as @a[tag=magik] at @s if score @s Mlvl < @s SPick run scoreboard players set @s SPick 1
execute as @a[tag=magik] at @s if score @s SPick matches ..0 run execute as @s at @s store result score @s SPick run scoreboard players get @s Mlvl
##execute as @a[tag=magik,predicate=first:has_wand_r] at @s if score @s SPick matches 2 run scoreboard players set @s SPick 3
##execute as @a[tag=magik,predicate=first:has_wand_l] at @s if score @s SPick matches 2 run scoreboard players set @s SPick 1

execute as @a[tag=magik,scores = {SpellCD = 0}] at @s run function first:spellfc/cdzero


execute as @a[tag=god,scores = {liosa_world = 1..,SpellCD = 0}] at @s run function first:spellfc/liosa/liosa_world
execute as @a[tag=god,scores = {liosa_limbo = 1..,SpellCD = 0}] at @s run function first:spellfc/liosa/liosa_limbo


execute as @e[type=area_effect_cloud,tag=telatu] at @s run function first:spellfc/mlvl9/telatuaectick
execute as @e[type=wolf,tag=SoulDog] at @s run function first:spellfc/mlvl9/witheraec
execute as @e[type=wolf,tag=ChaosKnight] at @s run function first:spellfc/mlvl9/chaosaec

execute as @e[type=area_effect_cloud,tag=truodes] at @s run function first:spellfc/mlvl10/truodesaec
execute as @e[type=area_effect_cloud,tag=carevo] at @s run function first:spellfc/mlvl11/carevoaec
execute as @e[type=area_effect_cloud,tag=rumdu] at @s run function first:spellfc/rumdu/rumduaec

execute as @e[tag=rusmu] at @s run function first:spellfc/rusmu/rusmu3
execute as @e[tag=nasad] at @s run function first:spellfc/nasa/nasatick

execute as @e[type=area_effect_cloud,tag=AirErasphaCosmetic] at @s run function first:spellfc/mlvl8/aircosm
execute as @e[type=area_effect_cloud,tag=fireeraspha] at @s run function first:spellfc/mlvl8/firecosm
execute as @e[type=area_effect_cloud,tag=iceeraspha] at @s run function first:spellfc/mlvl8/icecosm


##########################
#####  Race modifs  ######
##########################
execute as @a[tag=human] at @s run function first:racefc/humantick
execute as @a[tag=lutuk] at @s run function first:racefc/lutuktick
execute as @a[tag=xuluak] at @s run function first:racefc/xuluaktick
execute as @a[tag=renwik] at @s run function first:racefc/renwiktick
execute as @a[tag=skulkin] at @s run function first:racefc/skulkintick
execute as @a[tag=chorusian] at @s run function first:racefc/chorusiantick
execute as @a[tag=therwin] at @s run function first:racefc/therwintick
execute as @a[tag=qualak] at @s run function first:racefc/qualaktick
execute as @a[tag=cerglan] at @s run function first:racefc/cerglantick
execute as @a[tag=god] at @s run function first:racefc/god

execute as @a[tag=!renwik,predicate=first:renwik_eat] run item modify entity @s weapon.mainhand first:noteat
execute as @a[tag=renwik,predicate=first:renwik_eat] run item modify entity @s weapon.mainhand first:yeseat

execute as @a[tag=!lutuk,predicate=first:lutuk_eat] run item modify entity @s weapon.mainhand first:noteat
execute as @a[tag=lutuk,predicate=first:lutuk_eat] run item modify entity @s weapon.mainhand first:yeseat

##########################
#####  Enmaging  #########
##########################
execute as @a[tag=!magik,tag=!nethlock] at @s if predicate first:enmaging/enmaging run function first:enmaging/enmaging
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:stick"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{components:{"minecraft:custom_data":{MagicGem:5,Enchantments:[{}]}},id:"minecraft:emerald"}}] if block ~ ~-.75 ~ enchanting_table run function first:enmaging/wandcreme
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:stick"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{components:{"minecraft:custom_data":{MagicGem:5,Enchantments:[{}]}},id:"minecraft:lapis_lazuli"}}] if block ~ ~-.75 ~ enchanting_table run function first:enmaging/wandcrlap
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:stick"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{components:{"minecraft:custom_data":{MagicGem:5,Enchantments:[{}]}},id:"minecraft:quartz"}}] if block ~ ~-.75 ~ enchanting_table run function first:enmaging/wandcrqua
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:stick"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{components:{"minecraft:custom_data":{MagicGem:5,Enchantments:[{}]}},id:"minecraft:resin_clump"}}] if block ~ ~-.75 ~ enchanting_table run function first:enmaging/wandcrres

execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:paper"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:glow_ink_sac"}}] if block ~ ~-1 ~ lectern run function first:enmaging/scrolls/energy
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:paper"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:wither_rose"}}] if block ~ ~-1 ~ lectern run function first:enmaging/scrolls/desolation
execute as @a[tag=magik] at @s as @e[type=item,nbt={Item:{id:"minecraft:paper"}},distance=..5] at @s if entity @e[type=item,distance=..1,nbt={Item:{id:"minecraft:golden_apple"}}] if block ~ ~-1 ~ lectern run function first:enmaging/scrolls/hype

##########################
#####  Corruption  #######
##########################
execute as @a[tag=lutuk,scores={Health = ..1000}] at @s if biome ~ ~ ~ deep_dark run function first:corrupt/lutskulk
execute as @a[tag=xuluak,scores={Health = ..1000}] at @s if dimension the_end run function first:corrupt/xulcho
execute as @a[tag=renwik,scores={Health = ..1000}] at @s if biome ~ ~ ~ soul_sand_valley run function first:corrupt/renther
execute as @a[tag=qualak,scores={Health = ..1000}] at @s if biome ~ ~ ~ ice_spikes run function first:corrupt/quacerg

#########################
#####  Structures  ######
#########################
execute as @e[type=armor_stand,tag=dead_shrine_marker] at @s if block ~ ~ ~ soul_fire run function first:boss/dbm/dbmsummon
execute as @e[type=armor_stand,tag= forgeCenter,scores={SpellCD=..1}] at @s if entity @p[tag=magik,scores={Mlvl = 7},distance=..5] run function first:structures/the_forge/active
execute as @e[type=armor_stand,tag= forgeCenter,scores={SpellCD=..1}] at @s if entity @p[tag=magik,scores={Mlvl = 7,Ghorn=1..},distance=..5] unless entity @e[type=giant,tag=forger] run function first:boss/forger/awake
execute as @a[tag=magik,scores={Ghorn=1..}] unless entity @e[type=armor_stand,tag=forgeCenter,distance=..5,limit=1] run scoreboard players set @s Ghorn 0
execute as @e[type=armor_stand,tag=forgeCenter] unless score @s SpellCD matches -1.. run scoreboard players set @s SpellCD 0

execute as @e[type=armor_stand,tag=enmagerUG] at @s unless score @s SpellCD matches 1.. if entity @p[distance=..10,tag=magik] run function first:structures/enmaging_shrine/tick
execute as @e[type=area_effect_cloud,tag=lvl9] at @s run function first:enmaging/lvl9/aeclvl9
execute as @e[type=area_effect_cloud,tag=lvl10] at @s run function first:enmaging/lvl10/aeclvl10
execute as @e[type=area_effect_cloud,tag=lvl11] at @s run function first:enmaging/lvl11/aeclvl11

execute as @e[type=interaction,tag=ttridfound] at @s if data entity @s interaction run function first:structures/trident/trident1
execute as @e[type=trident,nbt={item:{components:{"minecraft:enchantments":{"levels":{"first:maelstrom":1}}}},inGround:0b,LeftOwner:1b}] at @s run function first:artifact/maelstrom/tick
execute as @e[type=trident,nbt={item:{components:{"minecraft:enchantments":{"levels":{"first:maelstrom":1}}}},inGround:1b,DealtDamage:0b}] at @s run function first:artifact/maelstrom/tickig
execute as @e[type=area_effect_cloud,tag=maelstrom] at @s run function first:artifact/maelstrom/tickaec

execute as @e[type= armor_stand,tag=evilAltar] at @s run function first:structures/evil_altar/tick


execute as @e[type= armor_stand,tag=deadNinjaSummon,scores={SpellCD=..0}] at @s run function first:structures/forest_hall/tick
execute as @e[type= armor_stand,tag=deadNinjaSummon] unless score @s SpellCD matches 1.. at @s run scoreboard players set @s SpellCD 0

#########################
#####  Boss fights  #####
#########################
execute as @e[type=wither_skeleton,tag=DBMan,tag=boss] at @s run function first:boss/dbm/dbmtick
execute as @e[type=wither_skeleton,tag=DBMan] at @s run bossbar set dbm players @a[distance=..40]
execute if entity @e[type=wither_skeleton,tag=DBMan] run bossbar set dbm visible true
execute unless entity @e[type=wither_skeleton,tag=DBMan] run bossbar set dbm visible false
execute as @e[type=wither_skeleton,tag=DBMan] at @s store result bossbar dbm value run data get entity @s Health
execute at @e[type=falling_block,tag=SFP] run particle soul_fire_flame ~ ~ ~ .1 .1 .1 .01 10 normal @a
execute at @e[type=falling_block,tag=FP] run particle flame ~ ~ ~ .1 .1 .1 .01 10 normal @a
execute at @e[type=falling_block,tag=WP] run particle splash ~ ~ ~ .1 .1 .1 .01 10 normal @a

execute as @e[type=bogged,tag=deadninja] at @s run function first:boss/deadninja/tick

execute as @e[type=bogged,tag=deadninja] at @s run bossbar set dnj players @a[distance=..40]
execute if entity @e[type=bogged,tag=deadninja] run bossbar set dnj visible true
execute unless entity @e[type=bogged,tag=deadninja] run bossbar set dnj visible false
execute as @e[type=bogged,tag=deadninja] at @s store result bossbar dnj value run data get entity @s Health

execute as @e[type=giant,tag=forger] at @s run function first:boss/forger/tick
execute as @e[type=zombie,tag=ForgerBrain] at @s unless entity @e[type=giant,tag=forger] run kill @s
execute as @e[type=creeper,tag=forgewisp] at @s run particle lava ~ ~ ~ 0 0 0 0 1 normal @a
kill @e[type=area_effect_cloud,nbt={potion_contents:{custom_effects:[{duration:-1}]}}]

execute as @e[type=giant,tag=forger] at @s run bossbar set frg players @a[distance=..40]
execute if entity @e[type=giant,tag=forger] run bossbar set frg visible true
execute unless entity @e[type=giant,tag=forger] run bossbar set frg visible false
execute as @e[type=giant,tag=forger] at @s store result bossbar frg value run data get entity @s Health

execute as @e[type=drowned,tag=drowner] at @s run function first:boss/drowner/tick

execute as @e[type=drowned,tag=drowner] at @s run bossbar set drw players @a[distance=..40]
execute if entity @e[type=drowned,tag=drowner] run bossbar set drw visible true
execute unless entity @e[type=drowned,tag=drowner] run bossbar set drw visible false
execute as @e[type=drowned,tag=drowner] at @s store result bossbar drw value run data get entity @s Health

####################
###  Dimensions  ###
####################

execute as @a[tag=magik,predicate=first:getout] run function first:spellfc/outlimbo
execute as @a[tag=magik,scores={Mlvl= 7..},predicate=first:getin] run function first:spellfc/inlimbo

####################
####  Nethlock  ####
####################
execute as @a[tag=nethlock] run function first:nethlock/tick
execute as @e[type=zombie_horse,tag=Shorse,nbt=!{SaddleItem:{id:"minecraft:saddle"}}] run tp @s ~ -100 ~
execute as @e[tag=Cursed] at @s run function first:nethlock/cursed/tick
execute as @e[tag=!nethlock,predicate=first:artifact/cube] run damage @s 1 magic
execute as @e[tag=!nethlock,predicate=first:artifact/cube] at @s run playsound block.sculk_shrieker.shriek hostile @s ~ ~ ~ 1 0

#################
###  Rituals  ###
#################
execute as @e[type=area_effect_cloud,tag=meditate] at @s run function first:rituals/meditateaec
execute as @e[type=area_effect_cloud,tag=sacrifice] at @s run function first:rituals/sacrificeaec
execute as @e[type=area_effect_cloud,tag=vision] at @s run function first:rituals/visionaec
execute as @e[type=area_effect_cloud,tag=growth] at @s run function first:rituals/growthaec
execute as @e[type=area_effect_cloud,tag=resinate] at @s run function first:rituals/resinateaec

####test
##execute as @a[advancements={first:hidden/wand = true}] run function first:test/newrc

